/**
 * @file
 * @brief Implementation of startup system task.
 */
#ifndef STA_RTOS_SYSTEM_STARTUP_HPP
#define STA_RTOS_SYSTEM_STARTUP_HPP


/**
 * @defgroup STA_RTOS_Startup Startup task
 * @ingroup STA_RTOS_API
 * @brief Startup system task.
 *
 * Check @ref STA_RTOS_BuildConfig for configuration options.
 */


namespace sta
{
	namespace rtos
	{
		/**
		 * @brief Extra initialization run at start of startup task.
		 *
		 * May be overridden by application if required.
		 *
		 * @ingroup STA_RTOS_Startup
		 */
		void startupExtras(void * argument);
	} // namespace rtos
} // namespace sta


#endif // STA_RTOS_SYSTEM_STARTUP_HPP
